unit gp04u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

const ver='26 Nov 12';//Goes back at least to May 2007
      kbmX=400;
      kbmY=400;

type
  Tgp04f1 = class(TForm)
    Image1: TImage;
    buQuit: TButton;
    procedure FormCreate(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure Blob(iColor,iX,iY:integer);
  private
    { Private declarations }
    bmBMap:TBitMap;
    bBlobsX, bBlobsY, bBlobWidth, bBlobHeight, bMarginX, bMarginY:byte;

  public
    { Public declarations }
  end;

var
  gp04f1: Tgp04f1;

implementation

{$R *.DFM}

procedure Tgp04f1.buQuitClick(Sender: TObject);
begin
application.terminate;
end;

procedure Tgp04f1.FormCreate(Sender: TObject);
var c1,bX,bY:byte;

function NextByte:byte;
//Note that the variable c1 is being used badly.
const data='09f911029d74e35bd84156c5635688xx'+
'00102030405060708090a0b0c0d0e0f101112131415f6f7f8f9fafbfcfdfeffxx';
var sTmp:string;
begin
sTmp:=copy(data,c1*2+1,2);
if sTmp='xx' then begin
  c1:=0;
  sTmp:=copy(data,c1*2+1,2)
  end;
sTmp:='$'+sTmp;
result:=strtoint(sTmp);
inc(c1)
end;

begin
bmBmap:=TBitmap.create;
bmBmap.width:=kbmX;
bmBmap.height:=kbmY;

bMarginX:=4;bMarginY:=4;

bBlobsX:=8;
bBlobsY:=bBlobsX;

bBlobWidth:=(kbmX-bMarginX) div (bBlobsX+1);
bBlobWidth:=bBlobWidth-bMarginX;
bBlobHeight:=(kbmY-bMarginY) div (bBlobsY+1);
bBlobHeight:=bBlobHeight-bMarginY;

Image1.picture.graphic:=bmBmap;(*Assign the bitmap to the image component*)

randomize;
c1:=0;
for bY:=0 to bBlobsX do
  for bX:=0 to bBlobsY do Blob(NextByte,bX*(bBlobWidth+bMarginX),bY*(bBlobHeight+bMarginY));


gp04f1.caption:='GP04, version of '+ver;
application.title:='app title';

(*Scrap from development....
Image1.Picture.Bitmap.canvas.pen.color:=$888888;//Not needed in Delphi, but helpful in Lazarus
Image1.Picture.Bitmap.canvas.moveto(0,0);
Image1.Picture.Bitmap.canvas.lineto(kbmX,kbmY);
*)

end;//FormCreate

procedure Tgp04f1.Blob(iColor,iX,iY:integer);
var b0,b1,b2,b3:byte;

  function DecToRGB(br,bg,bb:byte):tcolor;
  begin
  result:=bb*256*256+bg*256+br;
  end;

  procedure SubSquare(bcolor,bx,by:byte;ixbig,iybig:integer);
  var c1:integer;
  //"bx" and "by" designate position inside bigger square. = 0 or 1
  //"ixbig", "iybig" designate position of larger square.
  const bssx=20; //Byte, SmallSquare dimension.
        bssy=bssx;
  begin
   with Image1.Picture.Bitmap.canvas do begin
    case bcolor of
      3:pen.color:=dectorgb(255,0,132);
      0:pen.color:=dectorgb(0,99,220);
      1:pen.color:=dectorgb(255,204,0);
      2:pen.color:=dectorgb(0,255,102)//no ; here
     else pen.color:=clwhite;
    end;//case;
   for c1:=0 to bssy do begin
     moveto(ixbig+bx*bssx,iybig+by*bssy+c1);
     lineto(ixbig+bssx+bx*bssx,iybig+by*bssy+c1);
     end;//for...
  end;//with
end;//subsquare

begin //Blob

b0:=icolor and $C0 div 64;
b1:=icolor and $30 div 16;
b2:=icolor and $C div 4;
b3:=icolor and $3;

SubSquare(b0,0,0,iX,iY);
SubSquare(b1,1,0,iX,iY);
SubSquare(b2,0,1,iX,iY);
SubSquare(b3,1,1,iX,iY);

end; //Blob

end.
